Import MaxGUI.Drivers
EnablePolledInput()

'Global jscrw=1920
'Global jscrh=1080
'Graphics jscrw,jscrh,32

Global fullw=DesktopWidth()-32
Global fullh=DesktopHeight()-64

fullw=1024
fullh=512
Global jscrw=2048
Global jscrh=1024
'Graphics fullw,fullh,0

Local MyWindow:TGadget=CreateWindow("JNKTitler", 8,8,fullw,fullh+32,Null,WINDOW_TITLEBAR|WINDOW_CENTERED)
Local MyCanvas:TGadget=CreateCanvas(0,0,jscrw,jscrh,MyWindow)
SetGadgetLayout MyCanvas,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
SetGraphics CanvasGraphics (MyCanvas)


Global verbPast$[]=["abode","alit","arisen","awoken","been","born/borne","beaten","become","befallen","begun","beheld","bent","bereft","besought","bet","bidden","bid","bound","bitten","bled","blown","broken","bred","brought","broadcast","built","burnt","burst","bust","bought","cast","caught","chidden","chosen","cloven/cleft","clung","clad","come","cost","crept","cut","dealt","dug","done","drawn","dreamt","drunk","driven","dwelt","eaten","fallen","fart","fed","felt","fought","found","fit","fled","flung","flown","forbidden","forecast","forgotten","forgiven","forsaken","frozen","gainsaid","got","girt","given","gone","graven","grown","hung","had","heard","hove","hewn","hidden","hit","held","hurt","inlaid","input","kept","knelt","knit","known","laden","laid","led","leant","leapt","learnt","left","lent","let","lain","lit","lost","made","meant","met","mistaken","mown","partaken","paid","pled","put","quit","read (???)","rent","rid","ridden","rung","risen","run","sawn","said","seen","sought","sold","sent","set","sewn","shaken","shaven","shorn","shed","shone","shit","shod","shot","shown","shrunk","shriven","shut","sung","sunk","sat","slain","slept","slid","slung","slunk","slit","smelt","smitten","spoken","sped","spelt","spent","spilt","spun","spat","split","spoilt","spread","sprung","stood","stolen","stuck","stung","stunk","strewn","stridden","stricken","strung","striven","sworn","sweat","swept","swollen","swum","swung","taken","taught","torn","told","thought","thriven","thrown","thrust","trodden","understood","woken","way-laid","worn","woven","wed","wept","welcomed","went","wet","won","wound","withdrawn","wrung","written"]
Global VerbS$[]=["abides","alights","arises","awakes","is","bears","beats","becomes","befalls","begins","beholds","bends","bereaves","beseeches","bets","bids","bids","binds","bites","bleeds","blows","breaks","breeds","brings","broadcasts","builds","burns","bursts","busts","buys","casts","catches","chides","chooses","cleaves","clings","clothes","comes","costs","creeps","cuts","deals","digs","does","draws","dreams","drinks","drives","dwells","eats","falls","farts","feeds","feels","fights","finds","fits","flees","flings","flies","forbids","forecasts","forgets","forgives","forsakes","freezes","gainsays","gets","girds","gives","goes","graves","grows","hangs","has","hears","heaves","hews","hides","hits","holds","hurts","inlays","inputs","keeps","kneels","knits","knows","lades","lays","leads","leans","leaps","learns","leaves","lends","lets","lies","lights","loses","makes","means","meets","mistakes","mows","partakes","pays","pleads","puts","quits","reads","rends","rids","rides","rings","rises","runs","saws","says","sees","seeks","sells","sends","sets","sews","shakes","shaves","shears","sheds","shines","shits","shoes","shoots","shows","shrinks","shrives","shuts","sings","sinks","sits","slays","sleeps","slides","slings","slinks","slits","smells","smites","speaks","speeds","spells","spends","spills","spins","spits","splits","spoils","spreads","springs","stands","steals","sticks","stings","stinks","strews","strides","strikes","strings","strives","swears","sweats","sweeps","swells","swims","swings","takes","teaches","tears","tells","thinks","thrives","throws","thrusts","treads","understands","wakes","way-lays","wears","weaves","weds","weeps","welcomes","wends","wets","wins","winds","withdraws","wrings","writes"]
Global Verbing$[]=["abiding","alighting","arising","awaking","being","bearing","beating","becoming","befalling","beginning","beholding","bending","bereaving","beseeching","betting","bidding","bidding","binding","biting","bleeding","blowing","breaking","breeding","bringing","broadcasting","building","burning","bursting","busting","buying","casting","catching","chiding","choosing","cleaving","clinging","clothing","coming","costing","creeping","cutting","dealing","digging","doing","drawing","dreaming","drinking","driving","dwelling","eating","falling","farting","feeding","feeling","fighting","finding","fitting","fleeing","flinging","flying","forbidding","forecasting","forgetting","forgiving","forsaking","freezing","gainsaying","getting","girding","giving","going","graving","growing","hanging","having","hearing","heaving","hewing","hiding","hitting","holding","hurting","inlaying","inputting","keeping","kneeling","knitting","knowing","lading","laying","leading","leaning","leaping","learning","leaving","lending","letting","lying","lighting","losing","making","meaning","meeting","mistaking","mowing","partaking","paying","pleading","putting","quitting","reading","rending","ridding","riding","ringing","rising","running","sawing","saying","seeing","seeking","selling","sending","setting","sewing","shaking","shaving","shearing","shedding","shining","shitting","shoeing","shooting","showing","shrinking","shriving","shutting","singing","sinking","sitting","slaying","sleeping","sliding","slinging","slinking","slitting","smelling","smiting","speaking","speeding","spelling","spending","spilling","spinning","spitting","splitting","spoiling","spreading","springing","standing","stealing","sticking","stinging","stinking","strewing","striding","striking","stringing","striving","swearing","sweating","sweeping","swelling","swimming","swinging","taking","teaching","tearing","telling","thinking","thriving","throwing","thrusting","treading","understanding","waking","way-laying","wearing","weaving","wedding","weeping","welcoming","wending","wetting","winning","winding","withdrawing","wringing","writing"]
Global Adverb$[]=["abnormally","aboard","about","abroad","absentmindedly","absolutely","abundantly","accidentally","accordingly","actively","actually","acutely","admiringly","affectionately","affirmatively","after","afterwards","agreeably","almost","already","always","amazingly","angrily","annoyingly","annually","anxiously","anyhow","anyplace","anyway","anywhere","appreciably","appropriately","around","arrogantly","aside","assuredly","astonishingly","away","awfully","awkwardly","badly","barely","bashfully","beautifully","before","begrudgingly","believably","bewilderedly","bewilderingly","bitterly","believably","bleakly","blindly","blissfully","boastfully","boldly","boyishly","bravely","briefly","brightly","brilliantly","briskly","brutally","busily","calmly","candidly","carefully","carelessly","casually","cautiously","certainly","charmingly","cheerfully","chiefly","childishly","cleanly","clearly","closely","cloudily","clumsily","coaxingly","coincidentally","coldly","colorfully","comfortably","commonly","compactly","compassionately","completely","confusedly","consequently","considerably","considerately","consistently","constantly","continually","continuously","coolly","correctly","courageously","covertly","cowardly","crazily","crossly","cruelly","curiously","cunningly","currently","customarily","cutely","daily","daintily","dangerously","daringly","darkly","dastardly","dearly","decently","deepy","defiantly","deftly","deliberately","delicately","delightfully","densely","diagonally","differently","diligently","dimly","directly","disorderly","divisively","docilely","dopily","doubtfully","down","dramatically","dreamily","during","eagerly","early","earnestly","easily","efficiently","effortlessly","elaborately","elegantly","eloquently","elsewhere","emotionally","endlessly","energetically","enjoyably","enormously","enough","enthusiastically","entirely","equally","especially","essentially","eternally","ethically","even","evenly","eventually","ever","evermore","everywhere","evidently","evocatively","exactly","exceedingly","exceptionally","excitedly","exclusively","explicitly","expressly","extensively","externally","extra","extraordinarily","extremely","fairly","faithfully","famously","far","fashionably","fast","fatally","favorably","ferociously","fervently","fiercely","fiery","finally","financially","finitely","fluently","fondly","foolishly","greedily","grimly","grudgingly","habitually","half-heartedly","handily","handsomely","haphazardly","happily","harmoniously","harshly","hastily","hatefully","hauntingly","healthily","heartily","heavily","helpfully","hence","highly","hitherto","honestly","hopelessly","horizontally","hourly","how","however","hugely","humorously","hungrily","hurriedly","hysterically","icily","identifiably","idiotically","imaginatively","immeasurably","immediately","immensely","impatiently","impressively","inappropriately","incessantly","incorrectly","indeed","independently","indoors","indubitably","inevitably","infinitely","informally","infrequently","innocently","inquisitively","instantly","intelligently","intensely","intently","interestingly","intermittently","internally","invariably","invisibly","inwardly","ironically","irrefutably","irritably","jaggedly","jauntily","jealously","jovially","joyfully","joylessly","joyously","jubilantly","loosely","loudly","lovingly","loyally","luckily","luxuriously","madly","magically","mainly","majestically","markedly","materially","meaningfully","meanly","meantime","meanwhile","measurably","mechanically","medically","menacingly","merely","merrily","methodically","mightily","miserably","mockingly","monthly","morally","more","moreover","mortally","mostly","much","mysteriously","nastily","naturally","naughtily","nearby","nearly","neatly","needily","negatively","nervously","never","nevertheless","next","nicely","nightly","noisily","normally","nosily","not","now","nowadays","numbly","obediently","obligingly","obnoxiously","obviously","occasionally","oddly","offensively","officially","often","ominously","once","only","openly","optimistically","orderly","ordinarily","outdoors","outrageously","outwardly","outwards","powerfully","presently","presumably","prettily","previously","primly","principally","probably","promptly","properly","proudly","punctually","puzzlingly","quaintly","queasily","questionably","questioningly","quicker","quickly","quietly","quirkily","quite","quizzically","randomly","rapidly","rarely","readily","really","reasonably","reassuringly","recently","recklessly","regularly","reliably","reluctantly","remarkably","repeatedly","reproachfully","resentfully","respectably","respectfully","responsibly","restfully","richly","ridiculously","righteously","rightfully","rightly","rigidly","roughly","routinely","rudely","ruthlessly","sadly","safely","scarcely","scarily","scientifically","searchingly","secretively","securely","sedately","seemingly","seldom","selfishly","selflessly","separately","seriously","shakily","shamelessly","sharply","sheepishly","shoddily","shortly","shrilly","specifically","spectacularly","speedily","spiritually","splendidly","sporadically","startlingly","steadily","stealthily","sternly","still","strenuously","stressfully","strictly","structurally","studiously","stupidly","stylishly","subsequently","substantially","subtly","successfully","suddenly","sufficiently","suitably","superficially","supremely","surely","surprisingly","suspiciously","sweetly","swiftly","sympathetically","systematically","temporarily","tenderly","tensely","tepidly","terribly","thankfully","then","there","thereby","thoroughly","thoughtfully","thus","tightly","today","together","tomorrow","too","totally","touchingly","tremendously","truly","truthfully","twice","ultimately","unabashedly","unanimously","unbearably","unbelievably","unemotionally","unethically","unexpectedly","unfailingly","unfavourably","unfortunately","uniformly","unilaterally","unimpressively","universally","unkindly","unnaturally","unnecessarily","victoriously","vigilantly","vigorously","violently","visibly","visually","vivaciously","voluntarily","warmly","weakly","wearily","weekly","well","wetly","when","where","while","whole-heartedly","wholly","why","wickedly","widely","wiggly","wildly","wilfully","willingly","wisely","woefully","wonderfully","worriedly","worthily","wrongly","yearly","yearningly","yesterday","yet","youthfully","zanily","zealously","zestfully","zestily"]

Global Noun$[]=["word","letter","number","person","pen","class","people","sound","water","side","place","man","men","woman","women","boy","girl","year","day","week","month","name","sentence","line","air","land","home","hand","house","picture","animal","mother","father","brother","sister","world","head","page","country","question","answer","school","plant","food","sun","state","eye","city","tree","farm","story","sea","night","day","life","north","south","east","west","child","children","example","paper","music","river","car","foot","feet","book","science","room","friend","idea","fish","mountain","horse","watch","color","face","wood","list","bird","body","dog","family","song","door","product","wind","ship","area","rock","order","fire","problem","piece","top","bottom","king","space"]


Global timestamp$=CurrentDate$()+CurrentTime$()
timestamp=Replace(timestamp,":"," ")
timestamp=Replace(timestamp,"-"," ")
timestamp=Replace(timestamp," "," ")

Cls;Flip

Reseed(MilliSecs())

Global guifont:TImageFont=LoadImageFont("Istok-Bold.ttf",24)
Global guifontb:TImageFont=LoadImageFont("Istok-Bold.ttf",14)

Global font:TImageFont[100]
Global logon

Global Decoration=0
Global Shadow=0
Global ShadowB=0

Global bits$[128]
Global order[128]

Global pal[1024]
img:TPixmap=LoadPixmapPNG("colours.png")
For x=0 To 7
For y=0 To 31
	pal[(y*8)+x]=ReadPixel(img,x,y)
Next
Next
img=Null

Global mx,my,mh

Global layer:TPixmap
Global complete:TPixmap
Global complete_i:TImage

Global title$="Text Goes Here"
Global Set[1024]
Global UseSet[1024]

JumbleAll()

Global DirSafe$=Replace$(title$,":","_")
DirSafe$=Replace$(title$,"!","_")
DirSafe$=Replace$(title$,"<","_")
DirSafe$=Replace$(title$,">","_")
DirSafe$=Replace$(title$,"/","_")
DirSafe$=Replace$(title$,"\","_")
DirSafe$=Replace$(title$,"?","_")
DirSafe$=Replace$(title$,"*","_")
DirSafe$=Replace$(title$,Chr$(34),"_")
DirSafe$=Replace$(title$,"'","_")
DirSafe$=Replace$(title$,".","_")
DirSafe$=Replace$(title$,",","_")

'CreateDir ("Output/"+DirSafe$)

TryAnother(2,0,0)
Repeat
Cls
SetColor(128,128,128)
DrawRect(0,0,fullw,fullh+32)
SetColor(180,180,180)
SetColor(80,80,80)

DrawRect(16,128,512,256)
SetColor(255,255,255)
DrawImage complete_i,16,128

quit=0
	PollEvent()
	Select EventID()
		Case EVENT_WINDOWCLOSE
			Quit=1
		
		Case EVENT_KEYDOWN
			i=EventData()
			Select i
				Case KEY_SPACE	kA=1
				Case KEY_RETURN kB=1
				Case KEY_ESCAPE kC=1 Quit=1
				Case KEY_F4		Quit=1
			End Select
	End Select

mx=MouseX()
my=MouseY()
mh=MouseHit(1)

SetImageFont(guifont)
SetColor(0,0,0)
DrawText("Title: ",10,10)
x=120
space=10
For n=1 To Len(title$)
	let$=Mid$(title$,n,1)
	If let$=" "
		If Set[space]=1 Then let$="|"
		If Set[space]<>1 Then let$="-";Set[Space]=0
		If MX>x And MX<x+TextWidth(" ") And MY>10 And MY<10+TextHeight("_") And mh
			Set[space]=1-Set[space];forced=1
		EndIf
		space=space+1
		If space>30 Then space=30
	EndIf
	DrawText(let$,x,10)
	x=x+TextWidth(Mid$(title$,n,1))
	
Next

Reseed(MilliSecs())
SetImageFont(guifontb)

If Button(16,50,"Random Gaps")
For n=10 To 30
Set[n]=Rand(0,1)
Next
forced=1
EndIf

If Button(166,50,"Random Title")
	NewTitle()
	JumbleAll()
	forced=1
EndIf


If Button(fullw-300,10,"Redraw") Then forced=1
If Button(fullw-150,10,"Draw Random") Then forced=2

y=fullh
y=y-40
If Button(fullw-150,y,"Randomise All") Then JumbleAll();forced=1

y=y-40
If Button(fullw-150,y,"Random Font") Then Set[5]=Rand(1024,5012);forced=1
If Button(fullw-300,y,"Next Font") Then Set[5]=(Set[5]+1) Mod 5012;forced=1
If Button(fullw-450,y,"Prev Font") Then Set[5]=(Set[5]-1) Mod 5012;forced=1
If Set[5]<0 Then Set[5]=5012+Set[5]

y=y-40
If Button(fullw-150,y,"Random Shadow") Then Set[3]=Rand(0,2);Set[4]=Rand(1,4);forced=1

txt$="Thin Shadow"
If Set[4]=2 Then txt$="Medium Shadow"
If Set[4]=3 Then txt$="Large Shadow"
If Set[4]=4 Then txt$="Epic Shadow"
If Button(fullw-300,y,txt$) Then Set[4]=(Set[4]+1);forced=1;If Set[4]>4 Then Set[4]=1

txt$="No Shadow"
If Set[3]=1 Then txt$="Drop Shadow"
If Set[3]=2 Then txt$="Full Shadow"
If Button(fullw-450,y,txt$) Then Set[3]=(Set[3]+1) Mod 3;forced=1


y=y-40
	If Button(fullw-150,y,"Random Palette") Then Set[6]=Rand(0,31);forced=1
	If Button(fullw-300,y,"Next Palette") Then Set[6]=(Set[6]+1) Mod 32;forced=1
	If Button(fullw-450,y,"Prev Palette") Then Set[6]=(Set[6]-1);forced=1
If Set[6]<0 Then Set[6]=31
If Set[6]>31 Then Set[6]=0

For x=0 To 7
	argb=Pal[(Set[6]*8)+x]
	br=(argb & $00FF0000) Shr 16
	bg=(argb & $0000FF00) Shr 8
	bb=(argb & $000000FF)
	SetColor(br,bg,bb)
	DrawRect(x*32+(fullw-450),y+24,32,8)
Next

y=y-40
	If Button(fullw-150,y,"Random Colours") Then Set[8]=Rand(0,100000000);forced=1
	If Button(fullw-300,y,"Next Colours") Then Set[8]=(Set[8]+1) Mod 100000000;forced=1
	If Button(fullw-450,y,"Prev Colours") Then Set[8]=(Set[8]-1);forced=1
If Set[8]<0 Then Set[8]=100000000
If Set[8]>100000000 Then Set[8]=0


y=y-40
	If Button(fullw-150,y,"Random Layout") Then Set[7]=Rand(0,100000000);forced=1
	If Button(fullw-300,y,"Next Layout") Then Set[7]=(Set[7]+1) Mod 100000000;forced=1
	If Button(fullw-450,y,"Prev Layout") Then Set[7]=(Set[7]-1);forced=1
If Set[7]<0 Then Set[7]=100000000
If Set[7]>100000000 Then Set[7]=0


y=y-40
	If Button(fullw-150,y,"Random Layers") Then Set[9]=Rand(0,100000000);forced=1
	If Button(fullw-300,y,"Next Layers") Then Set[9]=(Set[9]+1) Mod 100000000;forced=1
	If Button(fullw-450,y,"Prev Layers") Then Set[9]=(Set[9]-1);forced=1
If Set[9]<0 Then Set[9]=100000000
If Set[9]>100000000 Then Set[9]=0




y=fullh
y=y-40
If Button(16,y,"Render Logo") Then Cls;Flip;TryAnother(4,1,0);TryAnother(1,1,0);logon=logon+1;forced=1
If Button(166,y,"Render Random") Then Cls;Flip;For n=0 To 9;TryAnother(4,1,1);TryAnother(1,1,2);logon=logon+1;Next;forced=1
If Button(366,y,"Render Insane") Then wastit$=title$;Cls;Flip;For n=0 To 9;NewTitle$();TryAnother(4,1,1);TryAnother(1,1,2);logon=logon+1;Next;forced=1;title$=wastit$

y=y-40
If Button(16,y,"HD Logo") Then Cls;Flip;TryAnother(8,1,0);TryAnother(4,1,0);TryAnother(1,1,0);logon=logon+1;forced=1
If Button(166,y,"HD Random") Then Cls;Flip;For n=0 To 9;TryAnother(8,1,1);TryAnother(4,1,2);TryAnother(1,1,2);logon=logon+1;Next;forced=1
If Button(366,y,"HD Insane") Then wastit$=title$;Cls;Flip;For n=0 To 9;NewTitle$();TryAnother(8,1,1);TryAnother(4,1,2);TryAnother(1,1,2);logon=logon+1;Next;forced=1;title$=wastit$




ch=GetChar()
If ch>31 Then title$=title$+Chr$(ch)

d=(KeyHit(KEY_BACKSPACE) Or KeyHit(KEY_DELETE))
If d And (Len(title$)<2 Or KeyDown(KEY_LSHIFT) Or KeyDown(KEY_RSHIFT)) Then title$=""
If d And Len(title$)>1 Then title$=Left$(title$,Len(title$)-1);


Flip



If KeyHit(KEY_RETURN) Or forced=1 Then TryAnother(2,0,0)
If KeyHit(KEY_ENTER) Or forced=2 Then TryAnother(2,0,1)
forced=0

quitting=0
If KeyHit(KEY_ESCAPE) Or KeyHit(KEY_F4) Then quitting=1
If quit=1 Then quitting=1

Until quitting=1

End

Function Button(fx,fy,ftxt$)
w=140
SetColor(0,0,0)
DrawRect(fx,fy,w,24)
SetColor(255,255,255)
DrawRect(fx,fy,w-1,24-1)

SetColor(130,130,130)
DrawRect(fx+1,fy+1,w-2,22)
SetColor(255,255,255)
DrawText(ftxt$,(fx+(w/2))-(TextWidth(ftxt$)/2),(fy+12)-(TextHeight(ftxt$)/2) )

If mx>fx And mx<fx+w And my>fy And my<fy+24 And mh
	mh=0
	Return 1
EndIf

Return 0
End Function 

Function JumbleAll()
	JumbleUse()
	For n=0 To 1023
		Set[n]=UseSet[n]
	Next
End Function

Function JumbleUse()
	UseSet[1]=Rand(0,10000000)	 ' Seed
	
	UseSet[2]=Rand(0,0)	' Decoration
	UseSet[3]=Rand(0,2)	' Shadow
	UseSet[4]=Rand(1,4)	' Shadow Depth
	
	UseSet[5]=Rand(1024,5012)	' Font Selection

	UseSet[6]=Rand(0,31)		' Colour scheme
	
	UseSet[7]=Rand(0,10000000)	' Layout Seed

	UseSet[8]=Rand(0,10000000)	' Colour Seed

	UseSet[9]=Rand(0,10000000)	' Layer Seed
	
	' Space-Gaps
	For m=10 To 30;UseSet[m]=Rand(0,1);Next
End Function

Function TryAnother(scale, save=1, jumble=1)
If (jumble=0) 
	For n=0 To 1023
		UseSet[n]=Set[n]
	Next
EndIf


Reseed(MilliSecs())
If jumble=1
	JumbleUse()
EndIf

Reseed(UseSet[1])

If scale<1 Then scale=1
If scale>8 Then scale=8
jscrw=256*scale
jscrh=128*scale


complete=Null
GCCollect()
complete=CreatePixmap(jscrw,jscrh,PF_RGBA8888)


For x=0 To jscrw-1
For y=0 To jscrh-1
	WritePixel(complete,x,y,$00000000)
Next
Next

Decoration=UseSet[2]
Shadow=UseSet[3]
ShadowB=UseSet[4]*scale

layers=1
bf=1
bits$[1]=title$

space=10
For x=1 To Len(title)
	If Mid$(title$,x,1)=" "
	If UseSet[space]=1
		bits[layers]=Trim$(Mid$(title$,bf,x-bf))
		layers=layers+1
		bf=x
	EndIf
	space=space+1
	If space>30 Then space=30
	EndIf
Next
If bf<x And layers>1
	bits[layers]=Trim$(Mid$(title$,bf,x-bf))
EndIf


	' /\/\/\/\/\/\/\/\
	'	Layer Order
	' \/\/\/\/\/\/\/\/
	
Reseed(UseSet[9])
For x=1 To layers
'	Print x+":"+bits[x]
	order[x]=x
Next

For x=1 To layers
	t=order[x]
	r=Rand(1,layers)
	order[x]=order[r]
	order[r]=t
Next


	' /\/\/\/\/\/\/\/\
	'  Font Selection
	' \/\/\/\/\/\/\/\/
Reseed(UseSet[1]+37)
If KeyDown(KEY_ESCAPE) Then End
	count=UseSet[5]
	quickdir=ReadDir("fonts/")
	usefont$=""
	fin=0
		Repeat
			in$=NextFile(quickdir)
			If Lower$(Right$(in$,4))=".ttf"
				usefont$=in$
				count=count-1
				If count<1 Then fin=1
			EndIf
			If in$="" Then CloseDir(quickdir);quickdir=ReadDir("fonts/")
		Until fin=1
	CloseDir quickdir
	
	For x=1 To 32
		font[x]=LoadImageFont("fonts/"+usefont$,(x+8)*(scale*1.5),SMOOTHFONT)
	Next
	
Cls



' Pick size
uz=32
Reseed((UseSet[7]))

ygap#=(jscrh/(Float(layers)*Rnd(1.2,2.5)))
plusy#=(Float(jscrh)-Float(ygap*layers))*0.5

centery=(ygap/2)
For q=1 To layers
l=order[q]

Cls
	txt$=bits[l]
	SetImageFont font[z]
	
	Reseed(UseSet[8]+(order[q]*37))

	c=Rand(0,7)
	argb=pal[(UseSet[6]*8)+c]
	br=(argb & $00FF0000) Shr 16
	bg=(argb & $0000FF00) Shr 8
	bb=(argb & $000000FF)

	
		Reseed((UseSet[7]+(order[q]*37)))
		SetColor br,bg,bb
		just=Rand(0,8)

		z=uz+Rand(-2,2)
		If z<2 Then z=2
		If z>32 Then z=32
		
		Repeat
			fin=1
			SetImageFont(font[z])
			cx#=TextWidth(txt)
			cy#=TextHeight(txt)
	
			If just=0 Then dx=(jscrw/2)-(cx/2) 
			If just=1 Then dx=(jscrw/2)-(cx*0.75)
			If just=2 Then dx=(jscrw/2)-(cx*0.25)
			If just=3 Then dx=(jscrw*0.4)-(cx/2)
			If just=4 Then dx=(jscrw*0.6)-(cx/2)
			If just=5 Then dx=(jscrw*0.3)-(cx*0.25)
			If just=6 Then dx=(jscrw*0.7)-(cx*0.75)
			If just=7 Then dx=(jscrw*0.2)-(cx*0.15)
			If just=8 Then dx=(jscrw*0.8)-(cx*0.85)

			dy=((ygap*(l-1))+(centery))-(cy/2)
			dy=dy+plusy
			
			If (dx<24 Or dx+cx>jscrw-24 Or dy<24 Or dy+cy>jscrh-24) And z>2
'				Print "Off the Edge "+z
				z=z-1;fin=0
			EndIf
			
		Until fin=1	
			
		DrawText(txt$,dx,dy)
	
	Chomp()
	
	Decorate()
	
	Paste()

	SetImageFont font[1]
	SetColor 255,255,255
	DrawText(logon,10,10)

If save=1 Then Flip False

Next


' Grab and Save

'SavePixmapPNG(complete,"Output/"+dirsafe+"/"+Right$("000"+logon,3)+".png")
complete_i=LoadImage(complete)
If save=1 Then SavePixmapPNG(complete,"Output/"+Timestamp+"_"+Right$("000000"+logon,3)+"_"+scale+".png")

	
For x=1 To 32
	font[x]=Null
Next

GCCollect()
Delay 50

End Function



Function Chomp()
layer=GrabPixmap(0,0,jscrw,jscrh)
For x=0 To jscrw-1
For y=0 To jscrh-1
	argb=ReadPixel(layer,x,y)
	If (argb & $00FFFFFF)=$00000000 Then argb=$00000000
	WritePixel(layer,x,y,argb) 
Next
Next
End Function

Function Paste()
For x=0 To jscrw-1
For y=0 To jscrh-1
	argb=ReadPixel(layer,x,y)
	argb2=ReadPixel(complete,x,y)
	argb3=AlphaBlend(argb,argb2)
	WritePixel(complete,x,y,argb3)
Next
Next

layer=Null
GCCollect()
End Function

Function AlphaBlend(argb,argb2)
					ra#=(argb2 & $FF000000) Shr 24
					ba#=(argb & $FF000000) Shr 24
					
					r1#=(argb & $FF0000) Shr 16
					r2#=(argb2 & $FF0000) Shr 16
					g1#=(argb & $FF00) Shr 8
					g2#=(argb2 & $FF00) Shr 8
					b1#=(argb & $FF) 
					b2#=(argb2 & $FF)

					nr#=r1-(((r1-r2)/255)*ra#)
					If nr<0 Then nr=0
					If nr>255 Then nr=255
					ng#=g1-(((g1-g2)/255)*ra#)
					If ng<0 Then ng=0
					If ng>255 Then ng=255
					nb#=b1-(((b1-b2)/255)*ra#)
					If nb<0 Then nb=0
					If nb>255 Then nb=255
					
					ta=ba+ra
					If ta<0 Then ta=0
					If ta>255 Then ta=255
					ta=ta Shl 24
					If ra=<4 And ba<4 Then Return $00000000
					Return ta+(Int(nr) Shl 16)+(Int(ng) Shl 8)+Int(nb)
End Function

Function Decorate()
	

If shadow=1
mask:TPixmap=CopyPixmap(layer)
' Shadow - Plain
For x=0 To jscrw-1
For y=0 To jscrh-1
	If ((ReadPixel(mask,x,y) & $FF000000) Shr 24)<16
		tc=0;tp=0
		For d=0 To ShadowB
			ox=x-d
			oy=y-d
			If ox>-1 And oy>-1 And ox<jscrw And oy<jscrh
				tp=tp+1
				tc=tc+((ReadPixel(mask,ox,oy) & $FF000000) Shr 24)
			EndIf
		Next		
		If tp>0
			tc=tc/tp
			If tc<0 Then tc=0
			If tc>255 Then tc=255
			WritePixel(layer,x,y,(tc Shl 24)+0)
		EndIf
	EndIf
	
Next
Next	
mask=Null
GCCollect()
EndIf

If shadow=2
mask:TPixmap=CopyPixmap(layer)
' Shadow - Circular
For x=0 To jscrw-1
For y=0 To jscrh-1
	If ((ReadPixel(mask,x,y) & $FF000000) Shr 24)<16
		tc=0;tp=0
		For dx=0 To ShadowB
		For dy=0 To ShadowB
			If dx+dy>ShadowB
				ox=x-dx
				oy=y-dy
				If ox>-1 And oy>-1 And ox<jscrw And oy<jscrh
					tp=tp+1
					tc=tc+((ReadPixel(mask,ox,oy) & $FF000000) Shr 24)
				EndIf
			EndIf
		Next
		Next
		If tp>0
			tc=tc/tp
			If tc<0 Then tc=0
			If tc>255 Then tc=255
			WritePixel(layer,x,y,(tc Shl 24)+0)
		EndIf
	EndIf
	
Next
Next	
mask=Null
GCCollect()
EndIf

End Function

Function Reseed(seedint)
	SeedRnd(seedint)
	For n=0 To 128;r=Rand(0,100);Next
End Function


Function GetVerbPast$()
	Return VerbPast[Rand(0,VerbPast.length-1)]
End Function

Function GetVerbS$()
	Return VerbS[Rand(0,VerbS.length-1)]
End Function

Function GetVerbIng$()
	Return Verbing[Rand(0,Verbing.length-1)]
End Function

Function GetAdverb$()
	Return Adverb[Rand(0,Adverb.length-1)]
End Function

Function GetNoun$()
	f=Rand(1,2)
	Return Noun[Rand(0,Noun.length-1)]
End Function


Function NewTitle$()
	Reseed MilliSecs()
	
	a$=GetVerbs$()
	b$=GetVerbing$()
	c$=GetVerbPast$()
	d$=GetNoun$()
	d2$=GetNoun$()
	e$=GetAdverb$()
	
	struc=Rand(0,8)
	Select struc
		Case 0	title$=b+" of the "+d
		Case 1	title$="The "+b+" of "+d
		Case 2	title$="The "+d
		Case 3	title$="The "+b+" "+d
		Case 4	title$="The "+c+" "+d
		Case 5	title$=d+"'s "+d2
		Case 6	title$=d+" "+a
		Case 7	title$=d+" "+e+" "+a
		Case 8	title$="The "+d+" "+a+" "+e
	End Select
cap=1
t2$=title$
title$=""
For n=1 To Len(t2$)
	c$=Lower$(Mid$(t2$,n,1))
	If cap=1 Then c$=Upper$(c$);cap=0
	If c$=" " Then cap=1
	
	title$=title$+c$
Next

title$=Replace$(title," Of "," of ")
title$=Replace$(title," The "," the ")

End Function

